/*
 * Copyright (c) 2021, The Imaging Source Europe GmbH.  All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms and conditions of the GNU General Public License,
 * version 2, as published by the Free Software Foundation.
 *
 * This program is distributed in the hope it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#define TIS_SENSOR_CID_TRIGGER_MODE						(V4L2_CTRL_CLASS_USER + 0x3001)
#define TIS_SENSOR_CID_STROBE_MODE						(V4L2_CTRL_CLASS_USER + 0x3002)
#define TIS_SENSOR_CID_TRIGGER_SOFTWARE 				(V4L2_CTRL_CLASS_USER + 0x3003)
#define TIS_SENSOR_CID_DEVICE_SERIAL_NUMBER				(V4L2_CTRL_CLASS_USER + 0x3004)
#define TIS_SENSOR_CID_TRIGGER_SOURCE					(V4L2_CTRL_CLASS_USER + 0x3005)
#define TIS_SENSOR_CID_TRIGGER_IN_POLARITY				(V4L2_CTRL_CLASS_USER + 0x3006)
#define TIS_SENSOR_CID_GPOUT_MODE						(V4L2_CTRL_CLASS_USER + 0x3007)
#define TIS_SENSOR_CID_GPOUT_FUNCTION					(V4L2_CTRL_CLASS_USER + 0x3008)
#define TIS_SENSOR_CID_OFFSET_X							(V4L2_CTRL_CLASS_USER + 0x3009)
#define TIS_SENSOR_CID_OFFSET_Y							(V4L2_CTRL_CLASS_USER + 0x300A)
#define TIS_SENSOR_CID_OFFSET_AUTO_CENTER				(V4L2_CTRL_CLASS_USER + 0x300B)
#define TIS_SENSOR_CID_DEVICE_MODEL_NAME				(V4L2_CTRL_CLASS_USER + 0x300C)
#define TIS_SENSOR_CID_DEVICE_VENDOR_NAME				(V4L2_CTRL_CLASS_USER + 0x300D)
#define TIS_SENSOR_CID_MODE_RAW_FOURCC					(V4L2_CTRL_CLASS_USER + 0x300E)
#define TIS_SENSOR_CID_BLACK_LEVEL  					(V4L2_CTRL_CLASS_USER + 0x300F)
#define TIS_SENSOR_CID_TRIGGER_EXPOSURE_MODE			(V4L2_CTRL_CLASS_USER + 0x3010)
#define TIS_SENSOR_CID_STROBE_POLARITY         			(V4L2_CTRL_CLASS_USER + 0x3011)
#define TIS_SENSOR_CID_STROBE_DELAY         			(V4L2_CTRL_CLASS_USER + 0x3012)
#define TIS_SENSOR_CID_STROBE_DURATION         			(V4L2_CTRL_CLASS_USER + 0x3013)
#define TIS_SENSOR_CID_DEVICE_VALID                     (V4L2_CTRL_CLASS_USER + 0x3014)

#define TIS_SENSOR_CTRL_TRIGGER_MODE_OFF				0
#define TIS_SENSOR_CTRL_TRIGGER_MODE_ON					1

#define TIS_SENSOR_CTRL_STROBE_MODE_EXPOSURE			0
#define TIS_SENSOR_CTRL_STROBE_MODE_FIXED_DURATION      1

#define TIS_SENSOR_CTRL_TRIGGER_SOURCE_FPDLINK			0
#define TIS_SENSOR_CTRL_TRIGGER_SOURCE_PICOBLADE		1

#define TIS_SENSOR_CTRL_TRIGGER_IN_POLARITY_DEFAULT		0
#define TIS_SENSOR_CTRL_TRIGGER_IN_POLARITY_INVERT		1

#define TIS_SENSOR_CTRL_GPOUT_MODE_OPENDRAIN			0
#define TIS_SENSOR_CTRL_GPOUT_MODE_TTL					1

#define TIS_SENSOR_CTRL_GPOUT_FUNCTION_CONSTANTLOW		0
#define TIS_SENSOR_CTRL_GPOUT_FUNCTION_CONSTANTHIGH		1
#define TIS_SENSOR_CTRL_GPOUT_FUNCTION_STROBE			2

#define TIS_SENSOR_CTRL_EXPOSURE_MODE_TIMED             0
#define TIS_SENSOR_CTRL_EXPOSURE_MODE_TRIGGER_WIDTH     1

#define TIS_SENSOR_CTRL_STROBE_POLARITY_ACTIVE_HIGH     0
#define TIS_SENSOR_CTRL_STROBE_POLARITY_ACTIVE_LOW      1

#define TIS_SENSOR_CID_IMX390_SENSOR_OUTPUT_SELECT		(V4L2_CTRL_CLASS_USER + 0x3100)
#define TIS_SENSOR_CID_IMX390_EXPOSURE_RATIO			(V4L2_CTRL_CLASS_USER + 0x3101)
#define TIS_SENSOR_CID_IMX390_GAIN_OFFSET				(V4L2_CTRL_CLASS_USER + 0x3102)
#define TIS_SENSOR_CID_IMX390_SUBTRACT_SMPG_HEIGHT		(V4L2_CTRL_CLASS_USER + 0x3103)

#define TIS_SENSOR_CTRL_IMX390_OUTPUT_SEL_HDR			0
#define TIS_SENSOR_CTRL_IMX390_OUTPUT_SEL_SP1_HCG		1
#define TIS_SENSOR_CTRL_IMX390_OUTPUT_SEL_SP1_LCG		2
#define TIS_SENSOR_CTRL_IMX390_OUTPUT_SEL_SP2			3

